## centrifuge 1.0.3~beta

=== Makefile ===
#
# Copyright 2014, Daehwan Kim <infphilo@gmail.com>
#
# This file is part of Centrifuge, which is copied and modified from Makefile in the Bowtie2 package.
#
# Centrifuge is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Centrifuge is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Centrifuge.  If not, see <http://www.gnu.org/licenses/>.
#
#
# Makefile for centrifuge-bin, centrifuge-build, centrifuge-inspect
#

INC =
GCC_PREFIX = $(shell dirname `which gcc`)
GCC_SUFFIX =
CC = $(GCC_PREFIX)/gcc$(GCC_SUFFIX)
CPP = $(GCC_PREFIX)/g++$(GCC_SUFFIX)
CXX = $(CPP) #-fdiagnostics-color=always
HEADERS = $(wildcard *.h)
BOWTIE_MM = 1
BOWTIE_SHARED_MEM = 0

# Detect Cygwin or MinGW
WINDOWS = 0
CYGWIN = 0
MINGW = 0
ifneq (,$(findstring CYGWIN,$(shell uname)))
	WINDOWS = 1 
	CYGWIN = 1
	# POSIX memory-mapped files not currently supported on Windows
	BOWTIE_MM = 0
	BOWTIE_SHARED_MEM = 0
else
	ifneq (,$(findstring MINGW,$(shell uname)))
		WINDOWS = 1
		MINGW = 1
		# POSIX memory-mapped files not currently supported on Windows
		BOWTIE_MM = 0
		BOWTIE_SHARED_MEM = 0
	endif
endif

MACOS = 0
ifneq (,$(findstring Darwin,$(shell uname)))
	MACOS = 1
endif

POPCNT_CAPABILITY ?= 1
ifeq (1, $(POPCNT_CAPABILITY))
    EXTRA_FLAGS += -DPOPCNT_CAPABILITY
    INC += -I third_party
endif

MM_DEF = 

ifeq (1,$(BOWTIE_MM))
	MM_DEF = -DBOWTIE_MM
endif

SHMEM_DEF = 

ifeq (1,$(BOWTIE_SHARED_MEM))
	SHMEM_DEF = -DBOWTIE_SHARED_MEM
endif

PTHREAD_PKG =
PTHREAD_LIB = 

ifeq (1,$(MINGW))
	PTHREAD_LIB = 
else
	PTHREAD_LIB = -lpthread
endif

SEARCH_LIBS = 
BUILD_LIBS = 
INSPECT_LIBS =

ifeq (1,$(MINGW))
	BUILD_LIBS = 
	INSPECT_LIBS = 
endif

USE_SRA = 0
SRA_DEF =
SRA_LIB =
SERACH_INC = 
ifeq (1,$(USE_SRA))
	SRA_DEF = -DUSE_SRA
	SRA_LIB = -lncbi-ngs-c++-static -lngs-c++-static -lncbi-vdb-static -ldl
	SEARCH_INC += -I$(NCBI_NGS_DIR)/include -I$(NCBI_VDB_DIR)/include
	SEARCH_LIBS += -L$(NCBI_NGS_DIR)/lib64 -L$(NCBI_VDB_DIR)/lib64
endif

LIBS = $(PTHREAD_LIB)

SHARED_CPPS = ccnt_lut.cpp ref_read.cpp alphabet.cpp shmem.cpp \
	edit.cpp bt2_idx.cpp \
	reference.cpp ds.cpp limit.cpp \
	random_source.cpp tinythread.cpp
SEARCH_CPPS = qual.cpp pat.cpp \
	read_qseq.cpp ref_coord.cpp mask.cpp \
	pe.cpp aligner_seed_policy.cpp \
	scoring.cpp presets.cpp \
	simple_func.cpp random_util.cpp outq.cpp

BUILD_CPPS = diff_sample.cpp

CENTRIFUGE_CPPS_MAIN = $(SEARCH_CPPS) centrifuge_main.cpp
CENTRIFUGE_BUILD_CPPS_MAIN = $(BUILD_CPPS) centrifuge_build_main.cpp
CENTRIFUGE_COMPRESS_CPPS_MAIN = $(BUILD_CPPS) \
	aligner_seed.cpp \
	aligner_sw.cpp \
	aligner_cache.cpp \
	dp_framer.cpp \
	aligner_bt.cpp sse_util.cpp \
	aligner_swsse.cpp \
	aligner_swsse_loc_i16.cpp \
	aligner_swsse_ee_i16.cpp \
	aligner_swsse_loc_u8.cpp \
	aligner_swsse_ee_u8.cpp \
	scoring.cpp \
	mask.cpp \
	qual.cpp

CENTRIFUGE_REPORT_CPPS_MAIN=$(BUILD_CPPS)

SEARCH_FRAGMENTS = $(wildcard search_*_phase*.c)
VERSION = $(shell cat VERSION)
GIT_VERSION = $(VERSION)
#GIT_VERSION = $(shell command -v git 2>&1 > /dev/null && git describe --long --tags --dirty --always --abbrev=10 || cat VERSION)

# Convert BITS=?? to a -m flag
BITS=32
ifeq (x86_64,$(shell uname -m))
BITS=64
endif
# msys will always be 32 bit so look at the cpu arch instead.
ifneq (,$(findstring AMD64,$(PROCESSOR_ARCHITEW6432)))
	ifeq (1,$(MINGW))
		BITS=64
	endif
endif
BITS_FLAG =

ifeq (32,$(BITS))
	BITS_FLAG = -m32
endif

ifeq (64,$(BITS))
	BITS_FLAG = -m64
endif
SSE_FLAG=-msse2

DEBUG_FLAGS    = -O0 -g3 $(BIToS_FLAG) $(SSE_FLAG)
DEBUG_DEFS     = -DCOMPILER_OPTIONS="\"$(DEBUG_FLAGS) $(EXTRA_FLAGS)\""
RELEASE_FLAGS  = -O3 $(BITS_FLAG) $(SSE_FLAG) -funroll-loops -g3
RELEASE_DEFS   = -DCOMPILER_OPTIONS="\"$(RELEASE_FLAGS) $(EXTRA_FLAGS)\""
NOASSERT_FLAGS = -DNDEBUG
FILE_FLAGS     = -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE
CFLAGS         = 
#CFLAGS         = -fdiagnostics-color=always

ifeq (1,$(USE_SRA))
	ifeq (1, $(MACOS))
		DEBUG_FLAGS += -mmacosx-version-min=10.6
		RELEASE_FLAGS += -mmacosx-version-min=10.6
	endif
endif


CENTRIFUGE_BIN_LIST = centrifuge-build-bin \
	centrifuge-class \
	centrifuge-inspect-bin

CENTRIFUGE_BIN_LIST_AUX = centrifuge-build-bin-debug \
	centrifuge-class-debug \
	centrifuge-inspect-bin-debug

CENTRIFUGE_SCRIPT_LIST = 	centrifuge \
	centrifuge-build \
	centrifuge-inspect \
	centrifuge-download \
	$(wildcard centrifuge-*.pl)


GENERAL_LIST = $(wildcard scripts/*.sh) \
	$(wildcard scripts/*.pl) \
	$(wildcard *.py) \
	$(wildcard *.pl) \
	doc/manual.inc.html \
	doc/README \
	doc/style.css \
	$(wildcard example/index/*.cf) \
	$(wildcard example/reads/*.fa) \
	$(wildcard example/reference/*) \
	indices/Makefile \
	$(PTHREAD_PKG) \
	$(CENTRIFUGE_SCRIPT_LIST) \
	AUTHORS \
	LICENSE \
	NEWS \
	MANUAL \
	MANUAL.markdown \
	TUTORIAL \
	VERSION

ifeq (1,$(WINDOWS))
	CENTRIFUGE_BIN_LIST := $(CENTRIFUGE_BIN_LIST) centrifuge.bat centrifuge-build.bat centrifuge-inspect.bat 
endif

# This is helpful on Windows under MinGW/MSYS, where Make might go for
# the Windows FIND tool instead.
FIND=$(shell which find)

SRC_PKG_LIST = $(wildcard *.h) \
	$(wildcard *.hh) \
	$(wildcard *.c) \
	$(wildcard *.cpp) \
	$(wildcard third_party/*.h) \
	$(wildcard third_party/*.cpp) \
	doc/strip_markdown.pl \
	Makefile \
	$(GENERAL_LIST)

BIN_PKG_LIST = $(GENERAL_LIST)

.PHONY: all allall both both-debug

all: $(CENTRIFUGE_BIN_LIST)

allall: $(CENTRIFUGE_BIN_LIST) $(CENTRIFUGE_BIN_LIST_AUX)

both: centrifuge-class centrifuge-build-bin

both-debug: centrifuge-class-debug centrifuge-build-bin-debug

DEFS=-fno-strict-aliasing \
     -DCENTRIFUGE_VERSION="\"$(GIT_VERSION)\"" \
     -DBUILD_HOST="\"`hostname`\"" \
     -DBUILD_TIME="\"`date`\"" \
     -DCOMPILER_VERSION="\"`$(CXX) -v 2>&1 | tail -1`\"" \
     $(FILE_FLAGS) \
	 $(CFLAGS) \
     $(PREF_DEF) \
     $(MM_DEF) \
     $(SHMEM_DEF)

#
# centrifuge targets
#

centrifuge-class: centrifuge.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(EXTRA_FLAGS) \
	$(DEFS) $(SRA_DEF) -DCENTRIFUGE -DBOWTIE2 -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS) -Wall \
	$(INC) $(SEARCH_INC) \
	-o $@ $< \
	$(SHARED_CPPS) $(CENTRIFUGE_CPPS_MAIN) \
	$(LIBS) $(SRA_LIB) $(SEARCH_LIBS)

centrifuge-class-debug: centrifuge.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(EXTRA_FLAGS) \
	$(DEFS) $(SRA_DEF) -DCENTRIFUGE -DBOWTIE2 -DBOWTIE_64BIT_INDEX -Wall \
	$(INC) $(SRA_LIB) $(SEARCH_INC) \
	-o $@ $< \
	$(SHARED_CPPS) $(CENTRIFUGE_CPPS_MAIN) \
	$(LIBS) $(SRA_LIB) $(SEARCH_LIBS)

centrifuge-build-bin: centrifuge_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(EXTRA_FLAGS) \
	$(DEFS) -DCENTRIFUGE -DBOWTIE2 -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS) -Wall \
	$(INC) \
	-o $@ $< \
	$(SHARED_CPPS) $(CENTRIFUGE_BUILD_CPPS_MAIN) \
	$(LIBS) $(BUILD_LIBS)

centrifuge-build-bin-debug: centrifuge_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(EXTRA_FLAGS) \
	$(DEFS) -DCENTRIFUGE -DBOWTIE2 -DBOWTIE_64BIT_INDEX -Wall \
	$(INC) \
	-o $@ $< \
	$(SHARED_CPPS) $(CENTRIFUGE_BUILD_CPPS_MAIN) \
	$(LIBS) $(BUILD_LIBS)

centrifuge-compress-bin: centrifuge_compress.cpp $(SHARED_CPPS) $(CENTRIFUGE_COMPRESS_CPPS_MAIN) $(HEADERS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(EXTRA_FLAGS) \
	$(DEFS) -DCENTRIFUGE -DBOWTIE2 -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS) -Wall \
	$(INC) \
	-o $@ $< \
	$(SHARED_CPPS) $(CENTRIFUGE_COMPRESS_CPPS_MAIN) \
	$(LIBS) $(BUILD_LIBS)

centrifuge-compress-bin-debug: centrifuge_compress.cpp $(SHARED_CPPS) $(CENTRIFUGE_COMPRESS_CPPS_MAIN) $(HEADERS)
	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(EXTRA_FLAGS) \
	$(DEFS) -DCENTRIFUGE -DBOWTIE2 -DBOWTIE_64BIT_INDEX -Wall \
	$(INC) \
	-o $@ $< \
	$(SHARED_CPPS) $(CENTRIFUGE_COMPRESS_CPPS_MAIN) \
	$(LIBS) $(BUILD_LIBS)

centrifuge-report-bin: centrifuge_report.cpp $(SHARED_CPPS) $(CENTRIFUGE_REPORT_CPPS_MAIN) $(HEADERS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(EXTRA_FLAGS) \
	$(DEFS) -DCENTRIFUGE -DBOWTIE2 -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS) -Wall \
	$(INC) \
	-o $@ $< \
	$(SHARED_CPPS) $(CENTRIFUGE_REPORT_CPPS_MAIN) \
	$(LIBS) $(BUILD_LIBS)

centrifuge-report-bin-debug: centrifuge_report.cpp $(SHARED_CPPS) $(CENTRIFUGE_REPORT_CPPS_MAIN) $(HEADERS)
	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(EXTRA_FLAGS) \
	$(DEFS) -DCENTRIFUGE -DBOWTIE2 -DBOWTIE_64BIT_INDEX -Wall \
	$(INC) \
	-o $@ $< \
	$(SHARED_CPPS) $(CENTRIFUGE_REPORT_CPPS_MAIN) \
	$(LIBS) $(BUILD_LIBS)

#centrifuge-RemoveN: centrifuge-RemoveN.cpp 
#	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(EXTRA_FLAGS) \
#	$(DEFS) -DCENTRIFUGE -DBOWTIE2 -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS) -Wall \
#	$(INC) \
#	-o $@ $< 


#
# centrifuge-inspect targets
#

centrifuge-inspect-bin: centrifuge_inspect.cpp $(HEADERS) $(SHARED_CPPS)
	$(CXX) $(RELEASE_FLAGS) \
	$(RELEASE_DEFS) $(EXTRA_FLAGS) \
	$(DEFS) -DCENTRIFUGE -DBOWTIE2 -DBOWTIE_64BIT_INDEX -Wall \
	$(INC) -I . \
	-o $@ $< \
	$(SHARED_CPPS) \
	$(LIBS) $(INSPECT_LIBS)

centrifuge-inspect-bin-debug: centrifuge_inspect.cpp $(HEADERS) $(SHARED_CPPS) 
	$(CXX) $(DEBUG_FLAGS) \
	$(DEBUG_DEFS) $(EXTRA_FLAGS) \
	$(DEFS) -DCENTRIFUGE -DBOWTIE2 -DBOWTIE_64BIT_INDEX -Wall \
	$(INC) -I . \
	-o $@ $< \
	$(SHARED_CPPS) \
	$(LIBS) $(INSPECT_LIBS)


centrifuge: ;

centrifuge.bat:
	echo "@echo off" > centrifuge.bat
	echo "perl %~dp0/centrifuge %*" >> centrifuge.bat

centrifuge-build.bat:
	echo "@echo off" > centrifuge-build.bat
	echo "python %~dp0/centrifuge-build %*" >> centrifuge-build.bat

centrifuge-inspect.bat:
	echo "@echo off" > centrifuge-inspect.bat
	echo "python %~dp0/centrifuge-inspect %*" >> centrifuge-inspect.bat


.PHONY: centrifuge-src
centrifuge-src: $(SRC_PKG_LIST)
	mkdir .src.tmp
	mkdir .src.tmp/centrifuge-$(VERSION)
	zip tmp.zip $(SRC_PKG_LIST)
	mv tmp.zip .src.tmp/centrifuge-$(VERSION)
	cd .src.tmp/centrifuge-$(VERSION) ; unzip tmp.zip ; rm -f tmp.zip
	cd .src.tmp ; zip -r centrifuge-$(VERSION)-source.zip centrifuge-$(VERSION)
	cp .src.tmp/centrifuge-$(VERSION)-source.zip .
	rm -rf .src.tmp

.PHONY: centrifuge-bin
centrifuge-bin: $(BIN_PKG_LIST) $(CENTRIFUGE_BIN_LIST) $(CENTRIFUGE_BIN_LIST_AUX) 
	rm -rf .bin.tmp
	mkdir .bin.tmp
	mkdir .bin.tmp/centrifuge-$(VERSION)
	if [ -f centrifuge.exe ] ; then \
		zip tmp.zip $(BIN_PKG_LIST) $(addsuffix .exe,$(CENTRIFUGE_BIN_LIST) $(CENTRIFUGE_BIN_LIST_AUX)) ; \
	else \
		zip tmp.zip $(BIN_PKG_LIST) $(CENTRIFUGE_BIN_LIST) $(CENTRIFUGE_BIN_LIST_AUX) ; \
	fi
	mv tmp.zip .bin.tmp/centrifuge-$(VERSION)
	cd .bin.tmp/centrifuge-$(VERSION) ; unzip tmp.zip ; rm -f tmp.zip
	cd .bin.tmp ; zip -r centrifuge-$(VERSION)-$(BITS).zip centrifuge-$(VERSION)
	cp .bin.tmp/centrifuge-$(VERSION)-$(BITS).zip .
	rm -rf .bin.tmp

.PHONY: doc
doc: doc/manual.inc.html MANUAL

doc/manual.inc.html: MANUAL.markdown
	pandoc -T "Centrifuge Manual" -o $@ \
	 --from markdown --to HTML --toc $^
	perl -i -ne \
	 '$$w=0 if m|^</body>|;print if $$w;$$w=1 if m|^<body>|;' $@

MANUAL: MANUAL.markdown
	perl doc/strip_markdown.pl < $^ > $@

prefix=/usr/local

.PHONY: install
install: all
	mkdir -p $(prefix)/bin
	mkdir -p $(prefix)/share/centrifuge/indices
	install -m 0644 indices/Makefile $(prefix)/share/centrifuge/indices
	install -d -m 0755 $(prefix)/share/centrifuge/doc
	install -m 0644 doc/* $(prefix)/share/centrifuge/doc
	for file in $(CENTRIFUGE_BIN_LIST) $(CENTRIFUGE_SCRIPT_LIST); do \
		install -m 0755 $$file $(prefix)/bin ; \
	done

.PHONY: uninstall
uninstall: all
	for file in $(CENTRIFUGE_BIN_LIST) $(CENTRIFUGE_SCRIPT_LIST); do \
		rm -v $(prefix)/bin/$$file ; \
		rm -v $(prefix)/share/centrifuge; \
	done


.PHONY: clean
clean:

=== indices/Makefile ===
#
# Makefile
# fbreitwieser, 2016-01-29 13:00
#

SHELL := /bin/bash

THREADS?=1
KEEP_FILES?=0

get_ref_file_names = $(addprefix $(REFERENCE_SEQUENCES_DIR)/, $(addsuffix $(1), \
	$(addprefix all-,$(COMPLETE_GENOMES)) \
	$(addprefix all-,$(addsuffix -chromosome_level,$(CHROMOSOME_LEVEL_GENOMES))) \
	$(addprefix mammalian-reference-,$(MAMMALIAN_TAXIDS)) \
	$(addprefix all-compressed-,$(COMPLETE_GENOMES_COMPRESSED)) \
	$(if $(INCLUDE_CONTAMINANTS),contaminants)))

DL_DIR=downloaded-seq
TMP_DIR?=tmp_$(IDX_NAME)
TAXID_SUFFIX:=.map
REFERENCE_SEQUENCES_DIR:=reference-sequences

.PHONY: index index-name index-size .path-ok .dustmasker-ok

define USAGE

Makefile to create common indices to use with Centrifuge.

  make [OPTIONS] TARGET

OPTIONS:
    THREADS=n          Number of threads for downloading, compression and
                       index building

STANDARD TARGETS:

    p_compressed        Download all bacteria genomes from RefSeq,
                        and compresses them at the species level

    p_compressed+h+v    p_compressed + human genome and transcripts,
                        contaminant sequences from UniVec and EmVec,
                        and all viral genomes

    p+h+v               As above, but with uncompressed bacterial genomes

Alternatively, a IDX_NAME and one or more genomes may be specified as
options to build a custom database.

EXTENDED OPTIONS:
	COMPLETE_GENOMES=s
	COMPLETE_GENOMES_COMPRESSED=s
	MAMMALIAN_TAXIDS=i
	INCLUDE_CONAMINANTS=1
	DONT_DUSTMASK=1
	IDX_NAME=s

EXAMPLES:
	# Make an index with all complete bacterial and archaeal genomes, and compress
	# the bacterial genomes to the species level
	make p_compressed

	# same as:
	make COMPLETE_GENOMES=archaea COMPLETE_GENOMES_COMPRESSED=bacteria IDX_NAME=p_compressed
	
	# Make an index with just the human genome
	make IDX_NAME=h MAMMALIAN_TAXIDS=9606

	# All archaeal genomes and contaminant sequences from UniVec and EmVec
	make IDX_NAME=a COMPLETE_GENOMES=archaea  INCLUDE_CONTAMINANTS=1 

endef
export USAGE

###################################################################################################
ifndef IDX_NAME

all: 
	@echo "$$USAGE"

IDX_NAME?=$(shell basename $(shell dirname $(abspath $(lastword $(MAKEFILE_LIST)))))

INDICES=p+h+v p_compressed p_compressed+h+v refseq_microbial refseq_full nt

p+h+v: export COMPLETE_GENOMES:=archaea bacteria viral
p+h+v: export MAMMALIAN_TAXIDS:=9606
p+h+v: export INCLUDE_CONTAMINANTS:=1
p+h+v: export IDX_NAME:=p+h+v

p_compressed: export COMPLETE_GENOMES:=
p_compressed: export COMPLETE_GENOMES_COMPRESSED:=archaea bacteria
p_compressed: export IDX_NAME:=p_compressed

p_compressed+h+v: export COMPLETE_GENOMES:=viral
p_compressed+h+v: export COMPLETE_GENOMES_COMPRESSED:=archaea bacteria
p_compressed+h+v: export MAMMALIAN_TAXIDS:=9606
p_compressed+h+v: export INCLUDE_CONTAMINANTS:=1
p_compressed+h+v: export IDX_NAME:=p_compressed+h+v

refseq_microbial: export COMPLETE_GENOMES:=archaea bacteria fungi protozoa viral
refseq_microbial: export CHROMOSOME_LEVEL_GENOMES:=$(COMPLETE_GENOMES)
##refseq_microbial: export SMALL_GENOMES:=mitochondrion plasmid plastid # TODO
refseq_microbial: export MAMMALIAN_TAXIDS:=9606 10090
refseq_microbial: export INCLUDE_CONTAMINANTS:=1
refseq_microbial: export IDX_NAME:=refseq_microbial
refseq_microbial: export CF_BUILD_OPTS+=--ftabchars 14

refseq_full: export COMPLETE_GENOMES:=archaea bacteria fungi invertebrate plant protozoa vertebrate_mammalian vertebrate_other viral
refseq_full: export CHROMOSOME_LEVEL_GENOMES:=$(COMPLETE_GENOMES)
refseq_full: export SMALL_GENOMES:=mitochondrion plasmid plastid
refseq_full: export MAMMALIAN_TAXIDS:=9606 10090
refseq_full: export INCLUDE_CONTAMINANTS:=1
refseq_full: export IDX_NAME:=refseq_full


nt: export IDX_NAME:=nt

$(INDICES):
	@echo Making: $@: $(IDX_NAME)
	$(MAKE) -f $(THIS_FILE) IDX_NAME=$(IDX_NAME)

####################################################################################################
else ## IDX_NAME is defined

DONT_DUSTMASK=
TAXONOMY_DOWNLOAD_OPTS?=
REFERENCE_SEQUENCES=$(call get_ref_file_names,.fna)
TAXID_MAPS=$(call get_ref_file_names,$(TAXID_SUFFIX))
CF_BUILD_OPTS?= 

ifeq (nt,$(IDX_NAME))
ifeq ($(strip $(DONT_DUSTMASK)),)
REFERENCE_SEQUENCES+=nt-dusted.fna
else
REFERENCE_SEQUENCES+=nt-sorted.fna
endif
TAXID_MAPS+=nt.map
CF_BUILD_OPTS+=--ftabchars=14
endif


ifeq ($(strip $(REFERENCE_SEQUENCES)),)
$(error REFERENCE_SEQUENCES is not set - specify at lease one of COMPLETE_GENOMES, \
COMPLETE_GENOMES_COMPRESSED, or MAMMALIAN_TAXIDS with the IDX_NAME ($(IDX_NAME)))
endif

SIZE_TABLES=$(addprefix $(REFERENCE_SEQUENCES_DIR)/all-compressed-,$(addsuffix .size,$(COMPLETE_GENOMES_COMPRESSED)))
ifneq ($(strip $(COMPLETE_GENOMES_COMPRESSED)),)
CF_BUILD_OPTS+=--size-table <(cat $(SIZE_TABLES))
endif

CF_DOWNLOAD_OPTS?=
CF_COMPRESS_OPTS?=
ifeq ($(strip $(DONT_DUSTMASK)),)
CF_DOWNLOAD_OPTS+=-m
else
CF_COMPRESS_OPTS+=--noDustmasker
endif

all: $(IDX_NAME).1.cf

# vim:ft=make
endif ## ifndef IDX_NAME

$(REFERENCE_SEQUENCES_DIR):
	mkdir -p $(REFERENCE_SEQUENCES_DIR)

#$(TAXID_MAPS): | $(REFERENCE_SEQUENCES_DIR)
#	rm $(patsubst %$(TAXID_SUFFIX),%.fna, $@)
#	$(MAKE) -f $(THIS_FILE) $(patsubst %$(TAXID_SUFFIX),%.fna, $@)

nt.gz:
	curl -o nt.gz ftp://ftp.ncbi.nih.gov/blast/db/FASTA/nt.gz

nt.fna: nt.gz
	gunzip -c nt.gz > nt.fna

accession2taxid/nucl_gb.accession2taxid.gz:
	mkdir -p accession2taxid
	curl ftp://ftp.ncbi.nlm.nih.gov/pub/taxonomy/accession2taxid/nucl_gb.accession2taxid.gz > accession2taxid/nucl_gb.accession2taxid.gz

accession2taxid/nucl_wgs.accession2taxid.gz:
	mkdir -p accession2taxid
	curl ftp://ftp.ncbi.nlm.nih.gov/pub/taxonomy/accession2taxid/nucl_wgs.accession2taxid.gz > accession2taxid/nucl_wgs.accession2taxid.gz

nt.map: nt-sorted.fna

nt-sorted.fna: nt.fna accession2taxid/nucl_gb.accession2taxid.gz accession2taxid/nucl_wgs.accession2taxid.gz
	centrifuge-sort-nt.pl -m nt.map -a nt-acs-wo-mapping.txt \
		nt.fna accession2taxid/nucl_gb.accession2taxid.gz accession2taxid/nucl_wgs.accession2taxid.gz \
		> nt-sorted.fna

nt-dusted.fna: nt-sorted.fna | .dustmasker-ok
	 dustmasker -infmt fasta -in nt-sorted.fna -level 20 -outfmt fasta | sed '/^>/! s/[^AGCT]/N/g' > nt-dusted.fna

$(REFERENCE_SEQUENCES_DIR)/mammalian-reference-%.fna: | $(REFERENCE_SEQUENCES_DIR)
	@[[ -d $(TMP_DIR) ]] && rm -rf $(TMP_DIR); mkdir -p $(TMP_DIR)
	centrifuge-download -o $(TMP_DIR) -d "vertebrate_mammalian" -a "Chromosome" -t $* -c 'reference genome' -P $(THREADS) refseq > \
		$(TMP_DIR)/$(patsubst %.fna,%$(TAXID_SUFFIX), $(notdir $@))
	cat $(TMP_DIR)/vertebrate_mammalian/*.fna > $@.tmp && mv $@.tmp $@
	mv $(TMP_DIR)/$(patsubst %.fna,%$(TAXID_SUFFIX),$(notdir $@)) $(patsubst %.fna,%$(TAXID_SUFFIX),$@)
ifeq (1,$(KEEP_FILES))
	[[ -d $(DL_DIR)/vertebrate_mammalian ]] || mkdir -p $(DL_DIR)/vertebrate_mammalian
	mv $(TMP_DIR)/vertebrate_mammalian/* $(DL_DIR)/vertebrate_mammalian
else
	rm -rf $(TMP_DIR)
endif

$(REFERENCE_SEQUENCES_DIR)/all-compressed-%.fna: | $(REFERENCE_SEQUENCES_DIR) taxonomy/nodes.dmp taxonomy/names.dmp .dustmasker-ok
	[[ -d $(TMP_DIR) ]] && rm -rf $(TMP_DIR); mkdir -p $(TMP_DIR)
	centrifuge-download -o $(TMP_DIR) -d "$*" -P $(THREADS) refseq > $(TMP_DIR)/all-$*.map
	time centrifuge-compress.pl $(TMP_DIR)/$* taxonomy $(CF_COMPRESS_OPTS) -map $(TMP_DIR)/all-$*.map \
		-o $@.tmp -t $(THREADS) -maxG 50000000 2>&1 | tee centrifuge-compress-$(IDX_NAME).log && \
	mv $@.tmp.fa $@ && mv $@.tmp.size $(patsubst %.fna,%.size,$@) && \
	mv $@.tmp.map $(patsubst %.fna,%$(TAXID_SUFFIX),$@)
ifeq (1,$(KEEP_FILES))
	[[ -d $(DL_DIR)/$* ]] || mkdir -p $(DL_DIR)/$*
	mv $(TMP_DIR)/$*/* $(DL_DIR)/$*
else
	rm -rf $(TMP_DIR)
endif

$(REFERENCE_SEQUENCES_DIR)/all-%.fna: | $(REFERENCE_SEQUENCES_DIR) .dustmasker-ok
	[[ -d $(TMP_DIR) ]] && rm -rf $(TMP_DIR); mkdir -p $(TMP_DIR)
	@echo Downloading and dust-masking $*
	centrifuge-download -o $(TMP_DIR) $(CF_DOWNLOAD_OPTS) -d "$*" -P $(THREADS) refseq > \
		$(TMP_DIR)/$(patsubst %.fna,%$(TAXID_SUFFIX),$(notdir $@))
	cat $(TMP_DIR)/$*/*.fna > $@.tmp && mv $@.tmp $@
	mv $(TMP_DIR)/$(patsubst %.fna,%$(TAXID_SUFFIX),$(notdir $@)) $(patsubst %.fna,%$(TAXID_SUFFIX),$@)
ifeq (1,$(KEEP_FILES))
	[[ -d $(DL_DIR)/$* ]] || mkdir -p $(DL_DIR)/$*
	mv $(TMP_DIR)/$*/* $(DL_DIR)/$*
else
	rm -rf $(TMP_DIR)
endif

$(REFERENCE_SEQUENCES_DIR)/all-%-chromosome_level.fna: | $(REFERENCE_SEQUENCES_DIR) .dustmasker-ok
	[[ -d $(TMP_DIR) ]] && rm -rf $(TMP_DIR); mkdir -p $(TMP_DIR)
	@echo Downloading and dust-masking $*
	centrifuge-download -o $(TMP_DIR) $(CF_DOWNLOAD_OPTS) -a "Chromosome" -d "$*" -P $(THREADS) refseq > \
		$(TMP_DIR)/$(patsubst %.fna,%$(TAXID_SUFFIX),$(notdir $@))
	cat $(TMP_DIR)/$*/*.fna > $@.tmp && mv $@.tmp $@
	mv $(TMP_DIR)/$(patsubst %.fna,%$(TAXID_SUFFIX),$(notdir $@)) $(patsubst %.fna,%$(TAXID_SUFFIX),$@)
ifeq (1,$(KEEP_FILES))
	[[ -d $(DL_DIR)/$* ]] || mkdir -p $(DL_DIR)/$*
	mv $(TMP_DIR)/$*/* $(DL_DIR)/$*
else
	rm -rf $(TMP_DIR)
endif



$(REFERENCE_SEQUENCES_DIR)/contaminants.fna: | $(REFERENCE_SEQUENCES_DIR)
	[[ -d $(TMP_DIR) ]] && rm -rf $(TMP_DIR); mkdir -p $(TMP_DIR)
	centrifuge-download -o $(TMP_DIR) contaminants > $(TMP_DIR)/$(patsubst %.fna,%$(TAXID_SUFFIX),$(notdir $@))
	cat $(TMP_DIR)/contaminants/*.fna > $@.tmp && mv $@.tmp $@
	mv $(TMP_DIR)/$(patsubst %.fna,%$(TAXID_SUFFIX),$(notdir $@)) $(patsubst %.fna,%$(TAXID_SUFFIX),$@)
ifeq (1,$(KEEP_FILES))
	[[ -d $(DL_DIR)/contaminants ]] || mkdir -p $(DL_DIR)/contaminants
	mv $(TMP_DIR)/contaminants/* $(DL_DIR)/$*
else
	rm -rf $(TMP_DIR)
endif

DUSTMASKER_EXISTS := $(shell command -v dustmasker)
.dustmasker-ok:
ifndef DUSTMASKER_EXISTS
ifeq ($(strip $(DONT_DUSTMASK)),)
	$(error dustmasker program does not exist. Install NCBI blast+, or set option DONT_DUSTMASK=1)
endif
endif
	

taxonomy/names.dmp: taxonomy/nodes.dmp
taxonomy/nodes.dmp: | .path-ok
	[[ -d $(TMP_DIR) ]] && rm -rf $(TMP_DIR); mkdir -p $(TMP_DIR)
	centrifuge-download $(TAXONOMY_DOWNLOAD_OPTS) -o $(TMP_DIR)/taxonomy taxonomy
	mkdir -p taxonomy
	mv $(TMP_DIR)/taxonomy/* taxonomy && rmdir $(TMP_DIR)/taxonomy && rmdir $(TMP_DIR)

$(IDX_NAME).1.cf: $(REFERENCE_SEQUENCES) $(SIZE_TABLES) $(TAXID_MAPS) taxonomy/nodes.dmp taxonomy/names.dmp | .path-ok
	@echo Index building prerequisites: $^
	[[ -d $(TMP_DIR) ]] && rm -rf $(TMP_DIR); mkdir -p $(TMP_DIR)
	time centrifuge-build -p $(THREADS) $(CF_BUILD_OPTS) \
		--conversion-table <(cat $(TAXID_MAPS)) \
		--taxonomy-tree taxonomy/nodes.dmp --name-table taxonomy/names.dmp \
		$(call join_w_comma,$(REFERENCE_SEQUENCES)) $(TMP_DIR)/$(IDX_NAME) 2>&1 | tee centrifuge-build-$(IDX_NAME).log
	mv $(TMP_DIR)/$(IDX_NAME).*.cf . && rmdir $(TMP_DIR)


clean:
	# Removing input sequences (all required information is in the index)
	rm -rf taxonomy
	rm -rf $(DL_DIR)
	rm -rf $(TMP_DIR)
	rm -rf tmp_*
	rm -rf reference-sequences
	rm -f *.map
	rm -f *.log

# Join a list with commas
COMMA:=,
EMPTY:=
SPACE:= $(EMPTY) $(EMPTY)
join_w_comma = $(subst $(SPACE),$(COMMA),$(strip $1))


THIS_FILE := $(lastword $(MAKEFILE_LIST))
PATH_OK  := $(shell command -v centrifuge-build 2> /dev/null && command -v centrifuge-download 2> /dev/null )
CF_BASE_DIR := $(shell dirname $(shell dirname $(THIS_FILE)))

error_msg := centrifuge-download and centrifuge-build are not available - please make sure they are in the path.
define n


endef

TEST_PROGRAMS=centrifuge-build centrifuge-download

ifneq ("$(wildcard $(CF_BASE_DIR)/centrifuge-build)","")
error_msg := $(error_msg)$n$nThe following command may solve this problem:$n  export PATH=$$PATH:"$(CF_BASE_DIR)"$n
endif

.path-ok:
ifndef PATH_OK
    $(error $n$(error_msg))
else
	@echo Found centrifuge-download and centrifuge-build.
endif

index-name:
	echo $(IDX_NAME)

index-size:
	du -csh $(IDX_NAME).[123].cf

=== debian/changelog ===
centrifuge (1.0.3~beta-2) unstable; urgency=medium

  * Move hisat2 and jellyfish to Build-Depends to make sure package builds
    only on those architectures where it can be installed later
  * -msse2 is already enabled by default on amd64 (which is the only
    architecture the package runs anyway)
    Closes: #890378
  * debhelper 11

 -- Andreas Tille <tille@debian.org>  Wed, 14 Feb 2018 14:18:27 +0100

centrifuge (1.0.3~beta-1) unstable; urgency=low

  * Initial release (Closes: #886463)

 -- Andreas Tille <tille@debian.org>  Sat, 06 Jan 2018 12:11:48 +0100

=== debian/control ===
Source: centrifuge
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 11~),
               hisat2,
               jellyfish
Standards-Version: 4.1.3
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/centrifuge.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/centrifuge.git
Homepage: https://ccb.jhu.edu/software/centrifuge/

Package: centrifuge
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         python,
         hisat2,
         jellyfish
Description: rapid and memory-efficient system for classification of DNA sequences
 Centrifuge is a very rapid and memory-efficient system for the
 classification of DNA sequences from microbial samples, with better
 sensitivity than and comparable accuracy to other leading systems. The
 system uses a novel indexing scheme based on the Burrows-Wheeler
 transform (BWT) and the Ferragina-Manzini (FM) index, optimized
 specifically for the metagenomic classification problem. Centrifuge
 requires a relatively small index (e.g., 4.3 GB for ~4,100 bacterial
 genomes) yet provides very fast classification speed, allowing it to
 process a typical DNA sequencing run within an hour. Together these
 advances enable timely and accurate analysis of large metagenomics data
 sets on conventional desktop computers.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

include /usr/share/dpkg/default.mk
# this provides:
# DEB_SOURCE: the source package name

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export POPCNT_CAPABILITY=0
%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- prefix=/usr/lib/centrifuge
	mv debian/$(DEB_SOURCE)/usr/lib/centrifuge/bin/* debian/$(DEB_SOURCE)/usr/lib/centrifuge/
	rmdir debian/$(DEB_SOURCE)/usr/lib/centrifuge/bin
	# move documentation to correct location
	mkdir -p debian/$(DEB_SOURCE)/usr/share/doc/$(DEB_SOURCE)/html
	mv debian/$(DEB_SOURCE)/usr/lib/centrifuge/share/$(DEB_SOURCE)/doc/*html \
	   debian/$(DEB_SOURCE)/usr/lib/centrifuge/share/$(DEB_SOURCE)/doc/*css  \
	   debian/$(DEB_SOURCE)/usr/share/doc/$(DEB_SOURCE)/html
	# remove useless stuff in documentation dir
	rm -rf debian/$(DEB_SOURCE)/usr/lib/centrifuge/share/doc/

=== debian/watch ===
version=4

opts="uversionmangle=s/-beta/~beta/" \
  https://github.com//infphilo/centrifuge/releases .*/archive/v(\d[\d.beta-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## centrifuge 1.0.3

=== Makefile ===
--- 
+++ 
@@ -191,6 +191,7 @@
 	centrifuge-build \
 	centrifuge-inspect \
 	centrifuge-download \
+	centrifuge-kreport \
 	$(wildcard centrifuge-*.pl)

=== debian/changelog ===
centrifuge (1.0.3-4) unstable; urgency=medium

  * Team Upload.
  [ Steffen Möller ]
  * Added ref to conda

  [ Nilesh Patra ]
  * Add autopkgtests
  * Remove empty
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)

 -- Nilesh Patra <npatra974@gmail.com>  Mon, 24 Aug 2020 18:19:52 +0530

centrifuge (1.0.3-3) unstable; urgency=medium

  * Use 2to3 to port to Python3
    Closes: #936281
  * debhelper-compat 12
  * Standards-Version: 4.4.0
  * use dh-python

 -- Andreas Tille <tille@debian.org>  Tue, 10 Sep 2019 08:20:22 +0200

centrifuge (1.0.3-2) unstable; urgency=medium

  [ Steffen Moeller ]
  * d/u/metadata:
    - added RRIDs
    - yamllint clean

  [ Jelmer Vernooĳ ]
  * Use secure copyright file specification URI.

  [ Andreas Tille ]
  * Do not report beta versions in watch file
  * Fix Perl interpreter path
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.3.0
  * Remove non-helpful docs

 -- Andreas Tille <tille@debian.org>  Mon, 07 Jan 2019 09:25:30 +0100

centrifuge (1.0.3-1) unstable; urgency=medium

  * New upstream release

 -- Andreas Tille <tille@debian.org>  Fri, 02 Mar 2018 19:59:50 +0100

=== debian/control ===
--- 
+++ 
@@ -3,19 +3,23 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 13),
+               dh-python,
+               dh-sequence-python3,
                hisat2,
                jellyfish
-Standards-Version: 4.1.3
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/centrifuge.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/centrifuge.git
+Standards-Version: 4.5.0
+Vcs-Browser: https://salsa.debian.org/med-team/centrifuge
+Vcs-Git: https://salsa.debian.org/med-team/centrifuge.git
 Homepage: https://ccb.jhu.edu/software/centrifuge/
+Rules-Requires-Root: no
 
 Package: centrifuge
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         python,
+         ${python3:Depends},
+         python3,
          hisat2,
          jellyfish
 Description: rapid and memory-efficient system for classification of DNA sequences

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export POPCNT_CAPABILITY=0
 %:
-	dh $@
+	dh $@ --with python3
 
 override_dh_auto_install:
 	dh_auto_install -- prefix=/usr/lib/centrifuge
@@ -22,3 +22,11 @@
 	   debian/$(DEB_SOURCE)/usr/share/doc/$(DEB_SOURCE)/html
 	# remove useless stuff in documentation dir
 	rm -rf debian/$(DEB_SOURCE)/usr/lib/centrifuge/share/doc/
+
+override_dh_install:
+	dh_install
+	for pl in `grep -Rl '#![[:space:]]*/usr/bin/env[[:space:]]\+perl' debian/*/usr/*` ; do \
+	    sed -i '1s?^#![[:space:]]*/usr/bin/env[[:space:]]\+perl?#!/usr/bin/perl?' $${pl} ; \
+	done
+	rm -rf debian/*/usr/lib/centrifuge/share/centrifuge/doc
+	find debian -name manual.inc.html | xargs rm -rf

=== debian/watch ===
version=4

https://github.com//infphilo/centrifuge/releases .*/archive/v?(\d[.\d]+)@ARCHIVE_EXT@

## centrifuge 1.0.4.1

=== debian/changelog ===
centrifuge (1.0.4.1-1) unstable; urgency=medium

  * New upstream version 1.0.4.1
  * d/control: add myself to uploaders.
  * d/control: declare compliance to standards version 4.7.0.
  * d/s/lintian-overrides: flag false positive missing source.
  * no_msse2.patch: unfuzz.
  * fix_auto_ptr_usage_in_gcc-7.patch: delete: applied upstream.
  * 0002-Fix-build-with-rank.patch: apparently not needed anymore.
  * d/copyright: refer to the versioned GPL-3 file.
  * d/salsa-ci.yml: disable i386 builds due to missing dependencies.
  * hardening.patch: also propagate CPPFLAGS.

 -- Étienne Mollier <emollier@debian.org>  Sun, 25 Aug 2024 17:19:30 +0200

centrifuge (1.0.3-12) unstable; urgency=medium

  * Team upload.
  * d/control: stop building on 32-bit architectures.
  * d/{upstream/metadata,copyright,watch}: link to the new repo

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 19 Mar 2024 18:50:22 +0100

centrifuge (1.0.3-11) unstable; urgency=medium

  * Builds reproducibly (thanks for the patch to Vagrant Cascadian)
    Closes: #1021513
  * Standards-Version: 4.6.1 (routine-update)
  * Set upstream metadata fields: Repository-Browse.
  * Lintian-overrides for false positive (see lintian bug #1017966)

 -- Andreas Tille <tille@debian.org>  Mon, 10 Oct 2022 07:52:41 +0200

centrifuge (1.0.3-10) unstable; urgency=medium

  * Really fix watch file

 -- Andreas Tille <tille@debian.org>  Sun, 05 Dec 2021 21:16:55 +0100

centrifuge (1.0.3-9) unstable; urgency=medium

  * Fix watchfile to detect new versions on github
  * Standards-Version: 4.6.0 (routine-update)
  * Fix manpages

 -- Andreas Tille <tille@debian.org>  Tue, 12 Oct 2021 08:43:55 +0200

centrifuge (1.0.3-8) unstable; urgency=medium

  [ Helmut Grohne ]
  * Improve cross building: Don't detect -m64 from uname.
    Closes: #973977

  [ Andreas Tille ]
  * Revert the patch from 1.0.3-6 in favour of above change

 -- Andreas Tille <tille@debian.org>  Mon, 09 Nov 2020 17:36:30 +0100

centrifuge (1.0.3-7) unstable; urgency=medium

  * Fix code to build on arm64

 -- Andreas Tille <tille@debian.org>  Sat, 07 Nov 2020 20:13:11 +0100

centrifuge (1.0.3-6) unstable; urgency=medium

  * Fix patch for other architectures than amd64

 -- Andreas Tille <tille@debian.org>  Sat, 07 Nov 2020 07:26:48 +0100

centrifuge (1.0.3-5) unstable; urgency=medium

  * Enable building on all architectures where jellyfish is available
  * No need to Build-Depend hisat2 since this is available on all
    architectures now.  Jellyfish is the restricting package for builds.
  * Test on all architectures where jellyfish is available

 -- Andreas Tille <tille@debian.org>  Fri, 06 Nov 2020 16:56:30 +0100

## centrifuge 1.0.4.2

=== Makefile ===
--- 
+++ 
@@ -162,9 +162,9 @@
 endif
 SSE_FLAG=-msse2
 
-DEBUG_FLAGS    = -O0 -g3 $(BIToS_FLAG) $(SSE_FLAG)
+DEBUG_FLAGS    = -O0 -g3 $(BIToS_FLAG) $(SSE_FLAG) -std=c++11
 DEBUG_DEFS     = -DCOMPILER_OPTIONS="\"$(DEBUG_FLAGS) $(EXTRA_FLAGS)\""
-RELEASE_FLAGS  = -O3 $(BITS_FLAG) $(SSE_FLAG) -funroll-loops -g3
+RELEASE_FLAGS  = -O3 $(BITS_FLAG) $(SSE_FLAG) -funroll-loops -g3 -std=c++11
 RELEASE_DEFS   = -DCOMPILER_OPTIONS="\"$(RELEASE_FLAGS) $(EXTRA_FLAGS)\""
 NOASSERT_FLAGS = -DNDEBUG
 FILE_FLAGS     = -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE
@@ -430,5 +430,3 @@
 	done
 
 
-.PHONY: clean
-clean:

=== indices/Makefile ===
--- 
+++ 
@@ -11,6 +11,7 @@
 get_ref_file_names = $(addprefix $(REFERENCE_SEQUENCES_DIR)/, $(addsuffix $(1), \
 	$(addprefix all-,$(COMPLETE_GENOMES)) \
 	$(addprefix all-,$(addsuffix -chromosome_level,$(CHROMOSOME_LEVEL_GENOMES))) \
+	$(addprefix all-,$(addsuffix -any_level,$(ANY_LEVEL_GENOMES))) \
 	$(addprefix mammalian-reference-,$(MAMMALIAN_TAXIDS)) \
 	$(addprefix all-compressed-,$(COMPLETE_GENOMES_COMPRESSED)) \
 	$(if $(INCLUDE_CONTAMINANTS),contaminants)))
@@ -42,6 +43,10 @@
                         and all viral genomes
 
     p+h+v               As above, but with uncompressed bacterial genomes
+
+	p+v
+
+	v
 
 Alternatively, a IDX_NAME and one or more genomes may be specified as
 options to build a custom database.
@@ -61,12 +66,12 @@
 
 	# same as:
 	make COMPLETE_GENOMES=archaea COMPLETE_GENOMES_COMPRESSED=bacteria IDX_NAME=p_compressed
-	
+
 	# Make an index with just the human genome
 	make IDX_NAME=h MAMMALIAN_TAXIDS=9606
 
 	# All archaeal genomes and contaminant sequences from UniVec and EmVec
-	make IDX_NAME=a COMPLETE_GENOMES=archaea  INCLUDE_CONTAMINANTS=1 
+	make IDX_NAME=a COMPLETE_GENOMES=archaea  INCLUDE_CONTAMINANTS=1
 
 endef
 export USAGE
@@ -74,30 +79,42 @@
 ###################################################################################################
 ifndef IDX_NAME
 
-all: 
+all:
 	@echo "$$USAGE"
 
 IDX_NAME?=$(shell basename $(shell dirname $(abspath $(lastword $(MAKEFILE_LIST)))))
 
-INDICES=p+h+v p_compressed p_compressed+h+v refseq_microbial refseq_full nt
-
-p+h+v: export COMPLETE_GENOMES:=archaea bacteria viral
+INDICES=p+h+v p+v v p p_compressed p_compressed+h+v refseq_microbial refseq_full nt
+
+p+h+v: export ANY_LEVEL_GENOMES:=viral
+p+h+v: export COMPLETE_GENOMES:=archaea bacteria
 p+h+v: export MAMMALIAN_TAXIDS:=9606
 p+h+v: export INCLUDE_CONTAMINANTS:=1
 p+h+v: export IDX_NAME:=p+h+v
 
-p_compressed: export COMPLETE_GENOMES:=
+p+v: export ANY_LEVEL_GENOMES:=viral
+p+v: export COMPLETE_GENOMES:=archaea bacteria
+p+v: export INCLUDE_CONTAMINANTS:=1
+p+v: export IDX_NAME:=p+v
+
+v: export ANY_LEVEL_GENOMES:=viral
+v: export IDX_NAME:=v
+
+p: export COMPLETE_GENOMES:=archaea bacteria
+p: export IDX_NAME:=p
+
 p_compressed: export COMPLETE_GENOMES_COMPRESSED:=archaea bacteria
 p_compressed: export IDX_NAME:=p_compressed
 
-p_compressed+h+v: export COMPLETE_GENOMES:=viral
+p_compressed+h+v: export ANY_LEVEL_GENOMES:=viral
 p_compressed+h+v: export COMPLETE_GENOMES_COMPRESSED:=archaea bacteria
 p_compressed+h+v: export MAMMALIAN_TAXIDS:=9606
 p_compressed+h+v: export INCLUDE_CONTAMINANTS:=1
 p_compressed+h+v: export IDX_NAME:=p_compressed+h+v
 
-refseq_microbial: export COMPLETE_GENOMES:=archaea bacteria fungi protozoa viral
+refseq_microbial: export COMPLETE_GENOMES:=archaea bacteria fungi protozoa
 refseq_microbial: export CHROMOSOME_LEVEL_GENOMES:=$(COMPLETE_GENOMES)
+refseq_microbial: export ANY_LEVEL_GENOMES:=viral
 ##refseq_microbial: export SMALL_GENOMES:=mitochondrion plasmid plastid # TODO
 refseq_microbial: export MAMMALIAN_TAXIDS:=9606 10090
 refseq_microbial: export INCLUDE_CONTAMINANTS:=1
@@ -106,6 +123,7 @@
 
 refseq_full: export COMPLETE_GENOMES:=archaea bacteria fungi invertebrate plant protozoa vertebrate_mammalian vertebrate_other viral
 refseq_full: export CHROMOSOME_LEVEL_GENOMES:=$(COMPLETE_GENOMES)
+refseq_full: export ANY_LEVEL_GENOMES:=viral
 refseq_full: export SMALL_GENOMES:=mitochondrion plasmid plastid
 refseq_full: export MAMMALIAN_TAXIDS:=9606 10090
 refseq_full: export INCLUDE_CONTAMINANTS:=1
@@ -125,7 +143,7 @@
 TAXONOMY_DOWNLOAD_OPTS?=
 REFERENCE_SEQUENCES=$(call get_ref_file_names,.fna)
 TAXID_MAPS=$(call get_ref_file_names,$(TAXID_SUFFIX))
-CF_BUILD_OPTS?= 
+CF_BUILD_OPTS?=
 
 ifeq (nt,$(IDX_NAME))
 ifeq ($(strip $(DONT_DUSTMASK)),)
@@ -196,7 +214,7 @@
 	@[[ -d $(TMP_DIR) ]] && rm -rf $(TMP_DIR); mkdir -p $(TMP_DIR)
 	centrifuge-download -o $(TMP_DIR) -d "vertebrate_mammalian" -a "Chromosome" -t $* -c 'reference genome' -P $(THREADS) refseq > \
 		$(TMP_DIR)/$(patsubst %.fna,%$(TAXID_SUFFIX), $(notdir $@))
-	cat $(TMP_DIR)/vertebrate_mammalian/*.fna > $@.tmp && mv $@.tmp $@
+	find $(TMP_DIR)/vertebrate_mammalian -name "*.fna" | xargs cat > $@.tmp && mv $@.tmp $@
 	mv $(TMP_DIR)/$(patsubst %.fna,%$(TAXID_SUFFIX),$(notdir $@)) $(patsubst %.fna,%$(TAXID_SUFFIX),$@)
 ifeq (1,$(KEEP_FILES))
 	[[ -d $(DL_DIR)/vertebrate_mammalian ]] || mkdir -p $(DL_DIR)/vertebrate_mammalian
@@ -219,12 +237,40 @@
 	rm -rf $(TMP_DIR)
 endif
 
+$(REFERENCE_SEQUENCES_DIR)/all-%-chromosome_level.fna: | $(REFERENCE_SEQUENCES_DIR) .dustmasker-ok
+	[[ -d $(TMP_DIR) ]] && rm -rf $(TMP_DIR); mkdir -p $(TMP_DIR)
+	@echo Downloading and dust-masking $*
+	centrifuge-download -o $(TMP_DIR) $(CF_DOWNLOAD_OPTS) -a "Chromosome" -d "$*" -P $(THREADS) refseq > \
+		$(TMP_DIR)/$(patsubst %.fna,%$(TAXID_SUFFIX),$(notdir $@))
+	find $(TMP_DIR)/$* -name "*.fna" | xargs cat > $@.tmp && mv $@.tmp $@
+	mv $(TMP_DIR)/$(patsubst %.fna,%$(TAXID_SUFFIX),$(notdir $@)) $(patsubst %.fna,%$(TAXID_SUFFIX),$@)
+ifeq (1,$(KEEP_FILES))
+	[[ -d $(DL_DIR)/$* ]] || mkdir -p $(DL_DIR)/$*
+	mv $(TMP_DIR)/$*/* $(DL_DIR)/$*
+else
+	rm -rf $(TMP_DIR)
+endif
+
+$(REFERENCE_SEQUENCES_DIR)/all-%-any_level.fna: | $(REFERENCE_SEQUENCES_DIR) .dustmasker-ok
+	[[ -d $(TMP_DIR) ]] && rm -rf $(TMP_DIR); mkdir -p $(TMP_DIR)
+	@echo Downloading and dust-masking $*
+	centrifuge-download -o $(TMP_DIR) $(CF_DOWNLOAD_OPTS) -a "Any" -d "$*" -P $(THREADS) refseq > \
+		$(TMP_DIR)/$(patsubst %.fna,%$(TAXID_SUFFIX),$(notdir $@))
+	find $(TMP_DIR)/$* -name "*.fna" | xargs cat > $@.tmp && mv $@.tmp $@
+	mv $(TMP_DIR)/$(patsubst %.fna,%$(TAXID_SUFFIX),$(notdir $@)) $(patsubst %.fna,%$(TAXID_SUFFIX),$@)
+ifeq (1,$(KEEP_FILES))
+	[[ -d $(DL_DIR)/$* ]] || mkdir -p $(DL_DIR)/$*
+	mv $(TMP_DIR)/$*/* $(DL_DIR)/$*
+else
+	rm -rf $(TMP_DIR)
+endif
+
 $(REFERENCE_SEQUENCES_DIR)/all-%.fna: | $(REFERENCE_SEQUENCES_DIR) .dustmasker-ok
 	[[ -d $(TMP_DIR) ]] && rm -rf $(TMP_DIR); mkdir -p $(TMP_DIR)
 	@echo Downloading and dust-masking $*
 	centrifuge-download -o $(TMP_DIR) $(CF_DOWNLOAD_OPTS) -d "$*" -P $(THREADS) refseq > \
 		$(TMP_DIR)/$(patsubst %.fna,%$(TAXID_SUFFIX),$(notdir $@))
-	cat $(TMP_DIR)/$*/*.fna > $@.tmp && mv $@.tmp $@
+	find $(TMP_DIR)/$* -name "*.fna" | xargs cat > $@.tmp && mv $@.tmp $@
 	mv $(TMP_DIR)/$(patsubst %.fna,%$(TAXID_SUFFIX),$(notdir $@)) $(patsubst %.fna,%$(TAXID_SUFFIX),$@)
 ifeq (1,$(KEEP_FILES))
 	[[ -d $(DL_DIR)/$* ]] || mkdir -p $(DL_DIR)/$*
@@ -233,26 +279,10 @@
 	rm -rf $(TMP_DIR)
 endif
 
-$(REFERENCE_SEQUENCES_DIR)/all-%-chromosome_level.fna: | $(REFERENCE_SEQUENCES_DIR) .dustmasker-ok
-	[[ -d $(TMP_DIR) ]] && rm -rf $(TMP_DIR); mkdir -p $(TMP_DIR)
-	@echo Downloading and dust-masking $*
-	centrifuge-download -o $(TMP_DIR) $(CF_DOWNLOAD_OPTS) -a "Chromosome" -d "$*" -P $(THREADS) refseq > \
-		$(TMP_DIR)/$(patsubst %.fna,%$(TAXID_SUFFIX),$(notdir $@))
-	cat $(TMP_DIR)/$*/*.fna > $@.tmp && mv $@.tmp $@
-	mv $(TMP_DIR)/$(patsubst %.fna,%$(TAXID_SUFFIX),$(notdir $@)) $(patsubst %.fna,%$(TAXID_SUFFIX),$@)
-ifeq (1,$(KEEP_FILES))
-	[[ -d $(DL_DIR)/$* ]] || mkdir -p $(DL_DIR)/$*
-	mv $(TMP_DIR)/$*/* $(DL_DIR)/$*
-else
-	rm -rf $(TMP_DIR)
-endif
-
-
-
 $(REFERENCE_SEQUENCES_DIR)/contaminants.fna: | $(REFERENCE_SEQUENCES_DIR)
 	[[ -d $(TMP_DIR) ]] && rm -rf $(TMP_DIR); mkdir -p $(TMP_DIR)
 	centrifuge-download -o $(TMP_DIR) contaminants > $(TMP_DIR)/$(patsubst %.fna,%$(TAXID_SUFFIX),$(notdir $@))
-	cat $(TMP_DIR)/contaminants/*.fna > $@.tmp && mv $@.tmp $@
+	find $(TMP_DIR)/contaminants -name "*.fna" | xargs cat > $@.tmp && mv $@.tmp $@
 	mv $(TMP_DIR)/$(patsubst %.fna,%$(TAXID_SUFFIX),$(notdir $@)) $(patsubst %.fna,%$(TAXID_SUFFIX),$@)
 ifeq (1,$(KEEP_FILES))
 	[[ -d $(DL_DIR)/contaminants ]] || mkdir -p $(DL_DIR)/contaminants
@@ -268,7 +298,7 @@
 	$(error dustmasker program does not exist. Install NCBI blast+, or set option DONT_DUSTMASK=1)
 endif
 endif
-	
+
 
 taxonomy/names.dmp: taxonomy/nodes.dmp
 taxonomy/nodes.dmp: | .path-ok
@@ -297,39 +327,3 @@
 	rm -f *.map
 	rm -f *.log
 
-# Join a list with commas
-COMMA:=,
-EMPTY:=
-SPACE:= $(EMPTY) $(EMPTY)
-join_w_comma = $(subst $(SPACE),$(COMMA),$(strip $1))
-
-
-THIS_FILE := $(lastword $(MAKEFILE_LIST))
-PATH_OK  := $(shell command -v centrifuge-build 2> /dev/null && command -v centrifuge-download 2> /dev/null )
-CF_BASE_DIR := $(shell dirname $(shell dirname $(THIS_FILE)))
-
-error_msg := centrifuge-download and centrifuge-build are not available - please make sure they are in the path.
-define n
-
-
-endef
-
-TEST_PROGRAMS=centrifuge-build centrifuge-download
-
-ifneq ("$(wildcard $(CF_BASE_DIR)/centrifuge-build)","")
-error_msg := $(error_msg)$n$nThe following command may solve this problem:$n  export PATH=$$PATH:"$(CF_BASE_DIR)"$n
-endif
-
-.path-ok:
-ifndef PATH_OK
-    $(error $n$(error_msg))
-else
-	@echo Found centrifuge-download and centrifuge-build.
-endif
-
-index-name:
-	echo $(IDX_NAME)
-
-index-size:
-	du -csh $(IDX_NAME).[123].cf
-

=== debian/changelog ===
centrifuge (1.0.4.2-1) unstable; urgency=medium

  * New upstream version 1.0.4.2

 -- Étienne Mollier <emollier@debian.org>  Mon, 28 Oct 2024 22:52:16 +0100

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,15 @@
 Source: centrifuge
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Andreas Tille <tille@debian.org>
+Uploaders: Andreas Tille <tille@debian.org>,
+           Étienne Mollier <emollier@debian.org>
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
+               architecture-is-64-bit,
                dh-python,
                dh-sequence-python3,
-               hisat2,
                jellyfish
-Standards-Version: 4.5.0
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/centrifuge
 Vcs-Git: https://salsa.debian.org/med-team/centrifuge.git
 Homepage: https://ccb.jhu.edu/software/centrifuge/

=== debian/rules ===
--- 
+++ 
@@ -10,6 +10,9 @@
 export POPCNT_CAPABILITY=0
 %:
 	dh $@ --with python3
+
+override_dh_auto_build:
+	dh_auto_build -- BITS=$(DEB_HOST_ARCH_BITS) BITS_FLAG=
 
 override_dh_auto_install:
 	dh_auto_install -- prefix=/usr/lib/centrifuge
